//--------------------------------------------------------------------
//                                                                    
//  Module:       SpreadSheet                                       
//  Description:  SpreadSheet
//                                                                    
//--------------------------------------------------------------------

import java.awt.*;
import java.awt.event.*;
import java.applet.*;
import java.util.*;
import java.io.*;
import java.net.*;


public class SpreadSheet extends JDPClassLayout  {

	JDPUser user;
	JDPJagg jaggSQL;
	JDPPopupMessage popuppanel;
	JDPMaskEdit JDPMaskEditMain;
	String moduleParameter;
	//
	//  Declare screen components
	//
	Panel Main;
	JDPTextGrid GridPanel1;

	public void InitClass(JDPUser user, Panel targetPanel, String moduleParameter) {

		this.user = user;
		this.moduleParameter = moduleParameter;
		//
		//  Set JAGG settings for this class
		//
		jaggSQL = new JDPJagg(user.jaggPath);

		setLayout(new BorderLayout());
		popuppanel = new JDPPopupMessage(user,this);
		add(popuppanel);
		JDPMaskEditMain = new JDPMaskEdit();

		Main = new Panel();
		GridPanel1 = new JDPTextGrid(user);

		Main.setLayout(new BorderLayout());
		add("Center", Main);
		Main.add("Center", GridPanel1);

		GridPanel1.setFont(new Font("Helvetica", Font.PLAIN, 11));
		GridPanel1.setForeground(user.u._cvtcolor("Black"));
		GridPanel1.setBackground(user.u._cvtcolor("LightGray"));


		//
		//  Initialise Components
		//
		InitComponents();
		//
		//  Add the handle to this panel to the global vector so other panels can
		//  access this one
		//
		user.gParm.addElement(this);
	}

	//
	//  Handle screen events
	//
	public boolean handleEvent(Event e) {

		switch (e.id) {
		case Event.KEY_ACTION:
			if (e.target.equals(GridPanel1)) {
				GridPanel1Recalc();
				return true;
			}
			return false;

		case Event.KEY_ACTION_RELEASE:
			if (e.target.equals(GridPanel1) && e.key == Event.KEY_ACTION_RELEASE) {
				GridPanel1Recalc();
				return true;
			}
			if (e.target.equals(GridPanel1) && e.key == Event.UP) {
				GridPanel1Recalc();
				return true;
			}
			if (e.target.equals(GridPanel1) && e.key == Event.DOWN) {
				GridPanel1Recalc();
				return true;
			}
			return false;

		case Event.LOST_FOCUS:
			if (e.target.equals(GridPanel1)) {
				
				return true;
			}
			return false;

		case Event.GOT_FOCUS:
			if (e.target.equals(GridPanel1)) {
				GridPanel1Recalc();
				return true;
			}
			return false;

		case Event.MOUSE_MOVE:
		case Event.MOUSE_ENTER:
		case Event.MOUSE_EXIT:
			popuppanel.postEvent(e);
			return false;

		default:
			return false;

		}
	}


	//
	//  Initialise other components by calling their methods
	//
	public void InitComponents() {

		GridPanel1.setTableDimensions(5,8);
		GridPanel1.setRowHeader(7,"Total:");
		for (int ix=0; ix<GridPanel1.getTableColumns(); ix++) {
			GridPanel1.setCellProtected(ix,GridPanel1.getTableRows()-1,true);
			GridPanel1.setCellColor(ix,GridPanel1.getTableRows()-1,Color.red);
		}
		GridPanel1.reDraw();
	}

	//
	//  New Method
	//
	public void GridPanel1Recalc() {

		for (int ix=0; ix<GridPanel1.getTableColumns(); ix++) {
			int totalValue = 0;
			for (int iy=0; iy<GridPanel1.getTableRows()-1; iy++) {
				try {
					totalValue += Integer.parseInt(GridPanel1.getText(ix,iy));
				} catch (Exception ex) {
				}	
			}	
			if (totalValue < 0) {
				GridPanel1.setCellColor(ix, GridPanel1.getTableRows()-1 ,Color.red);
			} else {
				GridPanel1.setCellColor(ix, GridPanel1.getTableRows()-1 ,Color.black);
			}
			GridPanel1.setText(Integer.toString(totalValue), ix, GridPanel1.getTableRows()-1);
		}		
	}


}

